package com.dlsm.task;
import com.dlsm.webapi.base.Mission;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.FutureTask;

public class MainScheduleManager {
    private boolean flag = false;
    public static ExecutorService EXECUTOR;
    public static ExecutorService MANAGER;
    private List<? extends Mission> taskInfoList;

    public MainScheduleManager() {
    }

    public void init(List<? extends Mission> taskInfoList, ExecutorService executor, ExecutorService manager) {
        this.taskInfoList = taskInfoList;
        EXECUTOR = executor;
        MANAGER = manager;
    }

    public void manageTask() {
        ScheduleTask scheduleTask = new ScheduleTask();
        scheduleTask.init(this.taskInfoList);
        this.startScheduleTask(scheduleTask);
    }

    private void startScheduleTask(ScheduleTask scheduleTask) {
        FutureTask<Mission> futureTask = new FutureTask(scheduleTask);
        MANAGER.submit(futureTask);
    }

    private boolean condition() {
        return false;
    }

    public boolean start() {
        this.flag = true;
        return this.flag;
    }

    public boolean stop() {
        return this.flag;
    }
}
