package com.dlsm.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class WebApiConfig {
    @Value("${webservice.url}")
    String webserviceUrl;
    @Value("${partnerID}")
    String partnerID;
    @Value("${unitID.middle}")
    String unitIDMiddle;
    @Value("${unitID.south}")
    String utitIDSouth;
    @Value("${md5}")
    String md5;

    public String getWebserviceUrl() {
        return this.webserviceUrl;
    }

    public String getPartnerID() {
        return this.partnerID;
    }

    public String getUnitIDMiddle() {
        return this.unitIDMiddle;
    }

    public String getUtitIDSouth() {
        return this.utitIDSouth;
    }

    public String getMd5() {
        return this.md5;
    }

    public void setWebserviceUrl(String webserviceUrl) {
        this.webserviceUrl = webserviceUrl;
    }

    public void setPartnerID(String partnerID) {
        this.partnerID = partnerID;
    }

    public void setUnitIDMiddle(String unitIDMiddle) {
        this.unitIDMiddle = unitIDMiddle;
    }

    public void setUtitIDSouth(String utitIDSouth) {
        this.utitIDSouth = utitIDSouth;
    }

    public void setMd5(String md5) {
        this.md5 = md5;
    }

    protected boolean canEqual(Object other) {
        return other instanceof WebApiConfig;
    }

    public String toString() {
        return "WebApiConfig(webserviceUrl=" + this.getWebserviceUrl() + ", partnerID=" + this.getPartnerID() + ", unitIDMiddle=" + this.getUnitIDMiddle() + ", utitIDSouth=" + this.getUtitIDSouth() + ", md5=" + this.getMd5() + ")";
    }

    public WebApiConfig() {
    }
}
