package com.dlsm.service.impl;

import com.dlsm.model.EndStation2;
import com.dlsm.service.EndStation2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 客运公交controller
 * @author xxg
 * @date 2023-02-03
 */

@Service
public class EndStation2ServiceImpl implements EndStation2Service {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public int insertEndStation2(EndStation2 endStation) {

        if(endStation==null)
        {
            return 0;
        }

        String sql = "insert into OUT_ENDSTATION2(OUT_ID,CREATE_TIME,Name,InputCode," +
                "AreaCode,AreaName,AreaType,SellStationCode,CityCode,CityName," +
                "ProvinceCode,ProvinceName,UnitID,UnitName,PhoneCode,PYInPutCode,LimitType) " +
                "values ('"+endStation.getOutId()+"','"+endStation.getCreateTime()+"'," +
                "'"+endStation.getName()+"','"+endStation.getInputCode()+"','"+endStation.getAreaCode()+"'," +
                "'"+endStation.getAreaName()+"','"+endStation.getAreaType()+"'," +
                "'"+endStation.getSellStationCode()+"','"+endStation.getCityCode()+"'," +
                "'"+endStation.getCityName()+"','"+endStation.getProvinceCode()+"'," +
                "'"+endStation.getProvinceName()+"','"+endStation.getUnitID()+"'," +
                "'"+endStation.getUnitName()+"','"+endStation.getPhoneCode()+"','"+endStation.getPYInPutCode()+"','"+endStation.getLimitType()+"')";

        System.out.println("OUT_ENDSTATION2="+sql);

        return jdbcTemplate.update(sql);

    }
}
