package com.dlsm.service.impl;

import com.dlsm.model.SellStations;
import com.dlsm.service.SellStationsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

/**
 * 客运公交controller
 * @author xxg
 * @date 2023-02-03
 */

@Service
public class SellStationsServiceImpl implements SellStationsService {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public int insertSellStations(SellStations sellStations) {

        if(sellStations==null)
        {
            return 0;
        }

        String sql = "insert into OUT_SELLSTATIONS(OUT_ID,CREATE_TIME,Name,KEY," +
                "UNITID,UNITNAME,CITYCODE,CITYNAME,STATIONID," +
                "STATIONNAME,SALEENABLED,PRESELLBEGINDATE,PRESELLENDDATE," +
                "CHECKTICKETENABLED,CHECKTICKETNOTE) " +
                "values ('"+sellStations.getOutId()+"','"+sellStations.getCreateTime()+"','"+sellStations.getName()+"'," +
                "'"+sellStations.getKey()+"','"+sellStations.getUnitID()+"','"+sellStations.getUnitName()+"','"+sellStations.getCityCode()+"'," +
                "'"+sellStations.getCityName()+"','"+sellStations.getStationID()+"','"+sellStations.getStationName()+"'," +
                "'"+sellStations.getStationID()+"','"+sellStations.getPresellBeginDate()+"'," +
                "'"+sellStations.getPresellEndDate()+"','"+sellStations.getCheckTicketEnabled()+"'," +
                "'"+sellStations.getCheckTicketNote()+"')";

        System.out.println("OUT_SELLSTATIONS="+sql);

        return jdbcTemplate.update(sql);

    }
}
